// ----------------------------------------------------------------------
// SOUL_MV Title Screen Reiuji.js
// Author: SoulPour777
// ----------------------------------------------------------------------

/*:
*
*
@help

// -------------------------------------------------------------------
// SOUL_MV Title Screen Reiuji.js
// Author: SoulPour777
// -------------------------------------------------------------------

Terms:

You are free to adapt this plugin. Preserve this help file.

You are free to use the plugin for commercial and non commercial use.

Credit Soulpour777 for the plugin.

*
* @plugindesc v1.0 An animated Title Screen by SoulPour777. (Title Screen Reiuji)
* @author SoulPour777 - soulxregalia.wordpress.com
*
* @param -- GAME TITLE --
* 
* @param Game Logo
* @desc The logo of your game shown in the title screen.
* @default Title
* 
* @param Game Logo X
* @desc X axis of the logo of your game shown in the title screen.
* @default 0
* 
* @param Game Logo Y
* @desc Y axis of the logo of your game shown in the title screen.
* @default 0
* 
* @param Logo Angle
* @desc The starting angle of the logo's duplicate movement animation.
* @default 0
* 
* @param Logo Center Scale
* @desc The starting scaling value of the logo's duplicate movement animation.
* @default 1
* 
* @param Logo Range
* @desc The starting scaling range of the logo's duplicate movement animation.
* @default 0.01
* 
* @param Logo Speed
* @desc The starting scaling speed of the logo's duplicate movement animation.
* @default 0.02
*
* @param -- BG SLIDESHOW --
* 
* @param Static Background
* @desc This is the background that covers the fading slideshow backgrounds.
* @default Background
*  
* @param Backgrounds
* @desc A list of backgrounds that are used as slideshow inside the title screen.
* @default overlay_1, overlay_2, overlay_3, overlay_4, overlay_5
* 
* @param Frame Wait
* @desc How many frames does the engine have to wait for another image to show?
* @default 240
* 
* @param Loop Slideshow
* @desc Would you like to loop the backgrounds on being shown as a slideshow?
* @default true
*
* @param -- OVERLAYS --
* 
* @param Frame
* @desc This is the frame image that covers the bottom left and upper right corners of the screen.
* @default Frame
* 
* @param Fog Overlay 1
* @desc This is the first overlay image that scrolls in the title screen.
* @default Fog_1
* 
* @param Overlay 1 Scroll X
* @desc Horizontal scroll speed of the first overlay.
* @default 1
* 
* @param Overlay 1 Scroll Y
* @desc Vertical scroll speed of the first overlay.
* @default 0
* 
* @param Fog Overlay 2
* @desc This is the second overlay image that scrolls in the title screen.
* @default Fog_2
* 
* @param Overlay 2 Scroll X
* @desc Horizontal scroll speed of the second overlay.
* @default -1
* 
* @param Overlay 2 Scroll Y
* @desc Vertical scroll speed of the second overlay.
* @default 0
* 
* @param -- CURSORS --
* 
* @param Command Cursor
* @desc The command cursor you are using that points to the current command.
* @default Cursor
* 
* @param Cursor Indicator
* @desc The flashing line that indicates what the current selected menu is.
* @default Line_Flash
* 
* @param Cursor Distance
* @desc The distance value of the cursor AWAY from the command buttons.
* @default 70
*
* @param -- BUTTONS --
* 
* @param New Game Button
* @desc The new game button image you are using.
* @default command_1
* 
* @param New Game Button X
* @desc New Game Button X Axis in the title screen.
* @default 280
* 
* @param New Game Button Y
* @desc New Game Button Y Axis in the title screen.
* @default 370
*
* @param Continue Button
* @desc The continue button image you are using.
* @default command_2
* 
* @param Continue Button X
* @desc Continue Button X Axis in the title screen.
* @default 320
* 
* @param Continue Button Y
* @desc Continue Button Y Axis in the title screen.
* @default 430
*
* @param Options Button
* @desc The options button image you are using.
* @default command_3
* 
* @param Options Button X
* @desc Options Button X Axis in the title screen.
* @default 340
* 
* @param Options Button Y
* @desc Options Button Y Axis in the title screen.
* @default 480
*
* @param Quit Button
* @desc The quit button image you are using.
* @default command_4
* 
* @param Quit Button X
* @desc Quit Button X Axis in the title screen.
* @default 360
* 
* @param Quit Button Y
* @desc Quit Button Y Axis in the title screen.
* @default 540
*
* @param -- PARTICLES --
*
* @param Spiral Particles Number
* @desc How many coil particles do you want to be shown on the screen?
* @default 13
*
* @param Spiral Max Speed
* @desc Maximum speed of the spiral coil particle movement. (Movement)
* @default 13
*
* @param Spiral Min Speed
* @desc Minimum speed of the spiral coil particle movement. (Movement)
* @default 5
*
* @param Spiral Max Amplifier
* @desc Maximum amplifier for the spiral coil particle movement. (Swirl Range and Speed)
* @default 100
*
* @param Spiral Min Amplifier
* @desc Minimum amplifier for the spiral coil particle movement. (Swirl Range and Speed)
* @default 20
*
* @param Particle Image 
* @desc The name of the particle you use (image name) (without "" marks).
* @default Particle
*
*/

(function(){

	var SOUL_MV = SOUL_MV || {};
	SOUL_MV.Reiuji = SOUL_MV.Reiuji || {};

	// Title
	SOUL_MV.Reiuji.gameLogo = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Game Logo'] || 'Title';
	SOUL_MV.Reiuji.gameLogoX = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Game Logo X'] || 0);
	SOUL_MV.Reiuji.gameLogoY = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Game Logo Y'] || 0);
	SOUL_MV.Reiuji.angle = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Logo Angle'] || 0);
	SOUL_MV.Reiuji.centerScale = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Logo Center Scale'] || 1);
	SOUL_MV.Reiuji.range = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Logo Range'] || 0.01);
	SOUL_MV.Reiuji.speed = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Logo Speed'] || 0.02);

	// Overlays
	SOUL_MV.Reiuji.frame = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Frame'] || 'Frame';
	SOUL_MV.Reiuji.fog1 = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Fog Overlay 1'] || 'Fog_1';
	SOUL_MV.Reiuji.fog1ScrollX = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Overlay 1 Scroll X'] || 1);
	SOUL_MV.Reiuji.fog1ScrollY = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Overlay 1 Scroll Y'] || 0);
	SOUL_MV.Reiuji.fog2ScrollX = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Overlay 2 Scroll X'] || -1);
	SOUL_MV.Reiuji.fog2ScrollY = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Overlay 2 Scroll Y'] || 0);	
	SOUL_MV.Reiuji.fog2 = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Fog Overlay 2'] || 'Fog_2';

	// Cursors
	SOUL_MV.Reiuji.cursorA = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Command Cursor'] || 'Cursor';
	SOUL_MV.Reiuji.cursorB = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Cursor Indicator'] || 'Line_Flash';
	SOUL_MV.Reiuji.curDis = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Cursor Distance'] || 70);

	// Slideshow
	SOUL_MV.Reiuji.backgroundZ = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Static Background'] || 'Background';
	SOUL_MV.Reiuji.slideshow = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Backgrounds'].split(/\s*,\s*/).filter(function(value) { return !!value; });
	SOUL_MV.Reiuji.frameWait = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Frame Wait'] || 240);
	SOUL_MV.Reiuji.loopAnimation = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Loop Slideshow'] === 'true' ? true : false;

	// Buttons
	SOUL_MV.Reiuji.newGameButton = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['New Game Button'] || 'command_1';
	SOUL_MV.Reiuji.newGameButtonX = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['New Game Button X'] || 280);
	SOUL_MV.Reiuji.newGameButtonY = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['New Game Button Y'] || 370);
	SOUL_MV.Reiuji.continueButton = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Continue Button'] || 'command_2';
	SOUL_MV.Reiuji.continueButtonX = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Continue Button X'] || 320);
	SOUL_MV.Reiuji.continueButtonY = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Continue Button Y'] || 430);	
	SOUL_MV.Reiuji.optionsButton = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Options Button'] || 'command_3';
	SOUL_MV.Reiuji.optionsButtonX = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Options Button X'] || 340);
	SOUL_MV.Reiuji.optionsButtonY = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Options Button Y'] || 480);	
	SOUL_MV.Reiuji.quitButton = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Quit Button'] || 'command_4';
	SOUL_MV.Reiuji.quitButtonX = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Quit Button X'] || 360);
	SOUL_MV.Reiuji.quitButtonY = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Quit Button Y'] || 540);	

	// Particles
	SOUL_MV.Reiuji.particleName = PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Particle Image'] || 'Particle';
	SOUL_MV.Reiuji.spiralCoils = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Spiral Particles Number'] || 13);
	SOUL_MV.Reiuji.spiralMaxSpeed = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Spiral Max Speed'] || 13);
	SOUL_MV.Reiuji.spiralMinSpeed = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Spiral Min Speed'] || 5);
	SOUL_MV.Reiuji.spiralMaxAmplifier = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Spiral Max Amplifier'] || 100);
	SOUL_MV.Reiuji.spiralMinAmplifier = Number(PluginManager.parameters('SOUL_MV Title Screen Reiuji')['Spiral Min Amplifier'] || 20);

    // COIL PARTICLES
    function Spiral_Coil() {
        this.initialize.apply(this, arguments);
    }

    Spiral_Coil.prototype = Object.create(Sprite_Base.prototype);
    Spiral_Coil.prototype.constructor = Spiral_Coil;


    Spiral_Coil.prototype.initialize = function() {
        this._maximumSpeed = SOUL_MV.Reiuji.spiralMaxSpeed;
        this._minimumSpeed = SOUL_MV.Reiuji.spiralMinSpeed;

        this._maxAmplifier = SOUL_MV.Reiuji.spiralMaxAmplifier;
        this._minimumAmplifier = SOUL_MV.Reiuji.spiralMinAmplifier;


        Sprite_Base.prototype.initialize.call(this);

        this.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.particleName);

        this.x = this.width / 2;
        this.amplitude = 1;
        this.speed = 1;
        this.radian = 0.0;
        this.reborn();


    }

    Spiral_Coil.prototype.reborn = function() {
        this.opacity = 255;
        this.amplitude = this._minimumAmplifier + Math.randomInt(this._maxAmplifier - this._minimumAmplifier);
        this.speed = Math.randomInt(3) + 1 + Math.randomInt(1);
        this.swingingSpeed = Math.random() * 0.1;
        this.radian = Math.random() * Math.random();
        this.xposition = Math.random() * Graphics.width;
        this.yposition = parseFloat(Graphics.height);
        this.bitmapMethod = soulpour_god_shuffle(Math['sin'], Math['cos']);
        this.y = this.yposition;
        this.x = this.xposition;
        this.scale.x = this.scale.y = 1.0;
    }

    function soulpour_god_shuffle(array) {
        for (var i = array.length - 1; i > 0; i--) {
            var j = Math.floor(Math.random() * (i + 1));
            var temp = array[i];
            array[i] = array[j];
            array[j] = temp;
        }
        return array;
    }    


    Spiral_Coil.prototype.update = function() {
        Sprite_Base.prototype.update.call(this);
        this.updateMovement();
        if(this.opacity <= 1) {
            this.reborn();
        } 
        var method = [Math.sin(this.radian), Math.cos(this.radian)];
        method = method[Math.floor(Math.random())];
        this.x = method * this.amplitude + this.xposition;  
    }

    Spiral_Coil.prototype.updateMovement = function() {
        this.radian += this.swingingSpeed;
        this.yposition -= this.speed;
        this.x = this.radian * this.amplitude + this.xposition;
        this.y = this.yposition;
        this.opacity -= 1;
    }  

	Scene_Title.prototype.create = function() {
	    Scene_Base.prototype.create.call(this);
	    this.initializePhase();
	    this.createBackground();
	    this.createAnimatedOverlay();
	    this.createBackgroundClone();
	    this.addAllChilds();
	    this.createForeground();
	    this.createMovingLayers();
	    this.createSpriteIndicator();
	    this.createSideFrame();
	    this.createWindowLayer();
	    this.createParticles();
	    this.createCommandWindow();
	    
	    this.createButtons();
	    this.createCursor();
	    
	};

	Scene_Title.prototype.createSpriteIndicator = function() {
		this.spriteIndicator = new Sprite_CursorIndicator();
		this.addChild(this.spriteIndicator);
	}

	Scene_Title.prototype.createCommandWindow = function() {
	    this._commandWindow = new Window_TitleCommand();
	    this._commandWindow.setHandler('newGame',  this.commandNewGame.bind(this));
	    this._commandWindow.setHandler('continue', this.commandContinue.bind(this));
	    this._commandWindow.setHandler('options',  this.commandOptions.bind(this));
	    this._commandWindow.setHandler('quit',  this.commandQuit.bind(this));
	    this.addWindow(this._commandWindow);
	};	

	Window_TitleCommand.prototype.makeCommandList = function() {
	    this.addCommand(TextManager.newGame,   'newGame');
	    this.addCommand(TextManager.continue_, 'continue', this.isContinueEnabled());
	    this.addCommand(TextManager.options,   'options');
	    this.addCommand('Quit',   'quit');
	};


	Scene_Title.prototype.commandQuit = function() {
		SceneManager.exit();
	}

	Scene_Title.prototype.createCursor = function() {
		this.cursor = new Sprite();
		this.cursor.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.cursorA);
		this.addChild(this.cursor);
	}

	Scene_Title.prototype.createButtons = function() {
		// replace command
		this._commandWindow.x = Graphics.boxWidth;
		this._commandWindow.y = Graphics.boxHeight;
		this.newGameButton = new Sprite_Button();
		this.newGameButton.x = SOUL_MV.Reiuji.newGameButtonX;
		this.newGameButton.y = SOUL_MV.Reiuji.newGameButtonY;
		this.newGameButton.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.newGameButton);
		this.continueButton = new Sprite_Button();
		this.continueButton.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.continueButton);
		this.continueButton.x = SOUL_MV.Reiuji.continueButtonX;
		this.continueButton.y = SOUL_MV.Reiuji.continueButtonY;		
		this.optionButton = new Sprite_Button();
		this.optionButton.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.optionsButton);
		this.optionButton.x = SOUL_MV.Reiuji.optionsButtonX;
		this.optionButton.y = SOUL_MV.Reiuji.optionsButtonY;		
		this.quitButton = new Sprite_Button();
		this.quitButton.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.quitButton);	
		this.quitButton.x = SOUL_MV.Reiuji.quitButtonX;
		this.quitButton.y = SOUL_MV.Reiuji.quitButtonY;		
		this.newGameButton.setClickHandler(this.commandNewGame.bind(this));	
		this.continueButton.setClickHandler(this.commandContinue.bind(this));
		this.optionButton.setClickHandler(this.commandOptions.bind(this));
		this.quitButton.setClickHandler(this.commandQuit.bind(this));					
		this.addChild(this.continueButton);
		this.addChild(this.newGameButton);
		this.addChild(this.optionButton);
		this.addChild(this.quitButton);
	}

	Scene_Title.prototype.createMovingLayers = function() {
		this._layer1 = new TilingSprite();
		this._layer1.move(0, 0, Graphics.width, Graphics.height);
		this._layer1.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.fog1);
		this._layer2 = new TilingSprite();
		this._layer2.move(0, 0, Graphics.width, Graphics.height);
		this._layer2.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.fog2);		
		this.addChildAt(this._layer1, 3);
		this.addChildAt(this._layer2, 4);
		this.addChildAt(this._backSprite2, 5);
	}

	Scene_Title.prototype.createSideFrame = function() {
		this.sideFrame = new Sprite();
		this.sideFrame.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.frame);
		this.addChild(this.sideFrame);
	}

    Scene_Title.prototype.createParticles = function() {
        this._particles = [];
        for (var i = 0; i < SOUL_MV.Reiuji.spiralCoils; i++) {
            var x = new Spiral_Coil();
            this._particles.push(x);
            this.addChild(this._particles[i]);
        }
    }



	Scene_Title.prototype.start = function() {
	    Scene_Base.prototype.start.call(this);
	    SceneManager.clearStack();
	    this.playTitleMusic();
	    this.startFadeIn(this.fadeSpeed(), false);
	};

	Scene_Title.prototype.addAllChilds = function() {
		this.addChildAt(this._backSprite1, 0);
		this.addChildAt(this.overlay, 1);
		this.addChildAt(this._backSprite3, 2);
		
	}

	Scene_Title.prototype.createBackgroundClone = function() {
		this._backSprite3 = new Sprite();
		this._backSprite3.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.gameLogo);
		this._backSprite3.x = SOUL_MV.Reiuji.gameLogoX;
		this._backSprite3.y = SOUL_MV.Reiuji.gameLogoY;
		this._backSprite3.anchor.x = 0;
		this._backSprite3.anchor.y = 0;
		this._backSprite3.opacity = 150;
	}

	Scene_Title.prototype.initializePhase = function() {
		this.phase = 0;
		this.waitTime = 0;
		this.frameWait = SOUL_MV.Reiuji.frameWait;
		this.finishPhase = false;
	}

	Scene_Title.prototype.createBackground = function() {
	    this._backSprite1 = new Sprite(ImageManager.loadTitle1(SOUL_MV.Reiuji.backgroundZ));
	    this._backSprite2 = new Sprite(ImageManager.loadTitle1(SOUL_MV.Reiuji.gameLogo));
	    this._backSprite2.x = SOUL_MV.Reiuji.gameLogoX;
	    this._backSprite2.y = SOUL_MV.Reiuji.gameLogoY;

	};

	Scene_Title.prototype.createAnimatedOverlay = function() {
		this.overlay = new Sprite(ImageManager.loadTitle1(SOUL_MV.Reiuji.slideshow[this.phase]));
		this.overlay.opacity = 0;
	}

	SOUL_MV.Reiuji._reiujiUpdate = Scene_Title.prototype.update;
	Scene_Title.prototype.update = function() {
	    SOUL_MV.Reiuji._reiujiUpdate.call(this);
	    if (Input.isTriggered('down')) {
		    if (this._commandWindow._index === 1 && !DataManager.isAnySavefileExists()) {
		    	this._commandWindow._index = 2;
		    }
	    }
	    if (Input.isTriggered('up')) {
		    if (this._commandWindow._index === 1 && !DataManager.isAnySavefileExists()) {
		    	this._commandWindow._index = 0;
		    }
	    }
	    this.animateCursor();
		this._layer1.origin.x += SOUL_MV.Reiuji.fog1ScrollX;
		this._layer1.origin.y += SOUL_MV.Reiuji.fog1ScrollY;	    
		this._layer2.origin.x += SOUL_MV.Reiuji.fog2ScrollX;
		this._layer2.origin.y += SOUL_MV.Reiuji.fog2ScrollY;
	    this._backSprite3.scale.x = SOUL_MV.Reiuji.centerScale + Math.sin(SOUL_MV.Reiuji.angle) * SOUL_MV.Reiuji.range;
	    this._backSprite3.scale.y = SOUL_MV.Reiuji.centerScale + Math.sin(SOUL_MV.Reiuji.angle) * SOUL_MV.Reiuji.range;
	    SOUL_MV.Reiuji.angle += SOUL_MV.Reiuji.speed;
	    if (this.finishPhase != true) {
	    	if (this.phase != SOUL_MV.Reiuji.slideshow.length) {
	    		if (this.overlay.opacity != 255) {
	    			this.overlay.opacity += 5;
	    		} else {
	    			if (this.waitTime != this.frameWait) {
	    				this.waitTime += 1;
	    			} else {
	    				if (this.phase < SOUL_MV.Reiuji.slideshow.length - 1) {
	    					this.phase += 1;
	    					this.overlay.opacity = 0;
	    				} else {
	    					if(SOUL_MV.Reiuji.loopAnimation) {
		    					// loop animation
		    					this.phase = 0;
		    					this.overlay.opacity = 0;
	    					} else {
		    					// loop animation
		    					this.finishPhase = true;
		    					this.overlay.opacity = 255;
	    					}

	    					// not looped animation
	    				}
	    				this.overlay.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.slideshow[this.phase]);
	    				this.waitTime = 0;
	    			}
	    		}
	    	}
	    }
	    this.overlay.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.slideshow[this.phase]);
	};

	Scene_Title.prototype.animateCursor = function() {
		switch(this._commandWindow._index) {
			case 0:
				this.cursor.x = this.newGameButton.x - SOUL_MV.Reiuji.curDis;
				this.cursor.y = this.newGameButton.y;
				this.spriteIndicator.y = this.newGameButton.y;
				break;
			case 1:
				this.cursor.x = this.continueButton.x - SOUL_MV.Reiuji.curDis;
				this.cursor.y = this.continueButton.y;
				this.spriteIndicator.y = this.continueButton.y;
				break;
			case 2:
				this.cursor.x = this.optionButton.x - SOUL_MV.Reiuji.curDis;
				this.cursor.y = this.optionButton.y;
				this.spriteIndicator.y = this.optionButton.y;
				break;
			case 3:
				this.cursor.x = this.quitButton.x - SOUL_MV.Reiuji.curDis;
				this.cursor.y = this.quitButton.y;
				this.spriteIndicator.y = this.quitButton.y;
				break;
		}
	}

	function Sprite_CursorIndicator() {
	    this.initialize.apply(this, arguments);
	}

	Sprite_CursorIndicator.prototype = Object.create(Sprite.prototype);
	Sprite_CursorIndicator.prototype.constructor = Sprite_CursorIndicator;

	Sprite_CursorIndicator.prototype.initialize = function() {
	    Sprite.prototype.initialize.call(this);
	    this.createBitmap();
	    this._frameCount = 0;
	};

	Sprite_CursorIndicator.prototype.update = function() {
	    Sprite.prototype.update.call(this);
	    this.updateAnimation();
	    this.visible = true;
	};

	Sprite_CursorIndicator.prototype.createBitmap = function() {
	    this.bitmap = ImageManager.loadTitle1(SOUL_MV.Reiuji.cursorB);
	};

	Sprite_CursorIndicator.prototype.updateAnimation = function() {
	    this._frameCount++;
	    this._frameCount %= 20;
	    this.opacity = (30 - this._frameCount) * 6;
	};


})();
